﻿using DevExpress.Maui.DataGrid;

namespace DevExpressDataGridBasics {
    public partial class MainPage : ContentPage {
        public MainPage() {
            InitializeComponent();
        }

        void DataGridView_ValidationError(object sender, ValidationErrorEventArgs e) {
            DisplayAlert("Validation Error", e.ErrorContent, "OK");
        }
        void DataGridView_CustomCellAppearance(object sender, CustomCellAppearanceEventArgs e) {
            if (e.RowHandle == DataGridView.AutoFilterRowHandle)
                return;
            if (e.FieldName == "ActualSales" || e.FieldName == "TargetSales") {
                double value = (double)dataGridView.GetCellValue(e.RowHandle, e.FieldName);
                if (value > 7000000)
                    e.FontColor = GetColorFromResource("GridCustomAppearancePositiveFontColor");
                else if (value < 4000000)
                    e.FontColor = GetColorFromResource("GridCustomAppearanceNegativeFontColor");
            }
        }

        Color GetColorFromResource(string resourceName) {
            return (Color)Resources[resourceName];
        }

        private void dataGridView_ValidateCell(object sender, DevExpress.Maui.DataGrid.ValidateCellEventArgs e) {
            if (e.FieldName == "ActualSales" || e.FieldName == "TargetSales") {
                if ((double)e.NewValue < 0)
                    e.ErrorContent = "Should be positive";
            }
        }
    }
}