using GridDatafromSQLite.ViewModels;
using Microsoft.Maui.Controls;
using SQLite;
using System.Net.Mail;
using static GridDatafromSQLite.App;

namespace GridDatafromSQLite;

public partial class ContactEditingPage : ContentPage {
    ContactEditingViewModel ViewModel;
    public ContactEditingPage(ContactEditingViewModel viewModel) {
        ViewModel = viewModel;
        InitializeComponent();
        BindingContext = viewModel;
    }

    private async void SaveItemClick(object sender, EventArgs e) {
        if (!dataForm.Validate())
            return;
        if (ViewModel.IsNewItemEditing)
            ViewModel.SourceCollection.Add(ViewModel.EditedItem);
        dataForm.Commit();
        try {
            if (ViewModel.IsNewItemEditing) {
                await Task.Run(() => DBContactService.Instance.InsertRecord(ViewModel.EditedItem));
            }
            else {
                await Task.Run(() => DBContactService.Instance.UpdateRecord(ViewModel.EditedItem));
            }
        }
        catch(Exception ex) {
            await DisplayAlert("Error", ex.Message, "OK");
        }
        await Navigation.PopAsync();
    }

    private void dataForm_ValidateProperty(object sender, DevExpress.Maui.DataForm.DataFormPropertyValidationEventArgs e) {
        if (e.PropertyName == "Email" && e.NewValue != null) {
            MailAddress res;
            if (!MailAddress.TryCreate((string)e.NewValue, out res)) {
                e.HasError = true;
                e.ErrorText = "Invalid email";
            }
        }
    }
}