using DevExpress.Maui.DataGrid;
using GridDatafromSQLite.Model;
using GridDatafromSQLite.ViewModels;
using SQLite;
using static GridDatafromSQLite.App;

namespace GridDatafromSQLite;

public partial class DetailInfoPage : ContentPage {
    DetailViewModel ViewModel;
    public DetailInfoPage(DetailViewModel viewModel) {
        InitializeComponent();
        ViewModel = viewModel;
        this.BindingContext = viewModel;
    }
    private async void EditItemClick(object sender, EventArgs e) {
        await Navigation.PushAsync(new ContactEditingPage(new ContactEditingViewModel(ViewModel.EditedItem)), true);
    }

    private void DeleteItemClick(object sender, EventArgs e) {
        popup.IsOpen = true;
    }

    private void DataFormView_ValidateProperty(object sender, DevExpress.Maui.DataForm.DataFormPropertyValidationEventArgs e) {
        e.ErrorText = e.PropertyName;
        e.HasError = true;
    }

    private void CancelDeleteClick(object sender, EventArgs e) {
        popup.IsOpen = false;
    }

    private async void DeleteConfirmedClick(object sender, EventArgs e) {
        try {
            DBContactService.Instance.DeleteRecord(ViewModel.EditedItem);
            ViewModel.SourceCollection.Remove(ViewModel.EditedItem);
        }
        catch (Exception ex) {
            await DisplayAlert("Error", ex.Message, "OK");
        }
        await Navigation.PopAsync();
    }

    #region stubs
    private async void MessageClick(object sender, EventArgs e) {
        await DisplayAlert("Send a message", "Click", "OK");
    }

    private async void CallClick(object sender, EventArgs e) {
        await DisplayAlert("Call", "Click", "OK");
    }

    private async void MailClick(object sender, EventArgs e) {
        await DisplayAlert("Send an email", "Click", "OK");
    }

    private async void CopyClick(object sender, EventArgs e) {
        await DisplayAlert("Copy", "Click", "OK");
    }

    private async void NavigateToCompanyClick(object sender, EventArgs e) {
        await DisplayAlert("Copy", "Navigate to company", "OK");
    }
    #endregion
}

