﻿using DevExpress.Maui.Controls;
using DevExpress.Maui.DataGrid;
using DevExpress.Maui.Editors;
using GridDatafromSQLite.ViewModels;
using System.Globalization;
using static GridDatafromSQLite.App;

namespace GridDatafromSQLite;

public partial class MainPage : ContentPage {
    public MainPage() {
        InitializeComponent();
    }
    private async void ItemClick(object sender, EventArgs e) {
        Model.Contact clickedContact = (Model.Contact)((CellData)((SimpleButton)sender).BindingContext).Item;
        DetailViewModel detailViewModel = new DetailViewModel(clickedContact, ((MainViewModel)BindingContext).Contacts);
        await Navigation.PushAsync(new DetailInfoPage(detailViewModel), true);
    }
    private async void AddButtonClick(object sender, EventArgs e) {
        ContactEditingViewModel contactEditingViewModel = new ContactEditingViewModel(new Model.Contact(), true, ((MainViewModel)BindingContext).Contacts);
        await Navigation.PushAsync(new ContactEditingPage(contactEditingViewModel), true);
    }
    private void SearchTextChanged(object sender, EventArgs e) {
        string searchText = ((TextEdit)sender).Text;
        dataGrid.FilterString = $"Contains([FirstName], '{searchText}') or Contains([LastName], '{searchText}')";
    }
}