﻿using GridDatafromSQLite.Model;
using SQLite;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using static GridDatafromSQLite.App;

namespace GridDatafromSQLite.ViewModels
{
    public class MainViewModel : BindableBase {
        bool isRefreshing;
        public MainViewModel() {
            
            LoadData();
            RefreshDataCommand = new Command(LoadData);
        }
        public async void LoadData() {
            IsRefreshing= true;
            var retrievedItems = await Task.Run(() => DBContactService.Instance.GetItems());
            Contacts = new ObservableCollection<Model.Contact>(retrievedItems);
            IsRefreshing = false;
        }
        ObservableCollection<Model.Contact> contacts;
        public ObservableCollection<Model.Contact> Contacts { get {return contacts; } set {
                contacts = value;
                RaisePropertyChanged();
            } }
        public ICommand RefreshDataCommand { get; set; }

        public bool IsRefreshing {
            get {
                return isRefreshing;
            }
            set {
                isRefreshing = value;
                RaisePropertyChanged();
            }
        }
    }

    public class BindableBase : INotifyPropertyChanged {
        public event PropertyChangedEventHandler PropertyChanged;
        public void RaisePropertyChanged([CallerMemberName] string propertyName = "") {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
